﻿using System;
using System.Windows;
using System.Windows.Media;

namespace ELTE.Windows.SmileyTransformations
{
    public partial class MainWindow : Window
    {
        private TransformGroup _TransformGroup; // transzformációs csoport
        private SkewTransform _TransformSkew; // nyújtás
        private RotateTransform _TransformRotate; // forgatás
        private TranslateTransform _TransformTranslate; // mozgatás
        private ScaleTransform _TransformScale; // nagyítás

        public MainWindow()
        {
            InitializeComponent();

            _TransformSkew = new SkewTransform(0, 0); // kezdeti értékek megadása
            _TransformRotate = new RotateTransform(0);
            _TransformTranslate = new TranslateTransform(0, 0);
            _TransformScale = new ScaleTransform(1, 1);

            _TransformGroup = new TransformGroup();
            _TransformGroup.Children.Add(_TransformSkew); // felvesszük a transzformációs csoport elemeit
            _TransformGroup.Children.Add(_TransformRotate);
            _TransformGroup.Children.Add(_TransformTranslate);
            _TransformGroup.Children.Add(_TransformScale);

            _RectangleSmiley.RenderTransform = _TransformGroup; // transzformációk megadása
            _SliderScaleX.Value = 1;
            _SliderScaleY.Value = 1;
        }

        private void ValueChanged(Object sender, RoutedEventArgs e)
        {
            _TransformRotate.Angle = _SliderRotateAngle.Value; // transzformációk értékeinek megadása
            _TransformRotate.CenterX = _SliderRotatePointX.Value;
            _TransformRotate.CenterY = _SliderRotatePointY.Value;

            _TransformScale.ScaleX = _SliderScaleX.Value;
            _TransformScale.ScaleY = _SliderScaleY.Value;
            _TransformScale.CenterX = _SliderScalePointX.Value;
            _TransformScale.CenterY = _SliderScalePointY.Value;

            _TransformSkew.AngleX = _SliderSkewX.Value;
            _TransformSkew.AngleY = _SliderSkewY.Value;
            _TransformSkew.CenterX = _SliderSkewPointX.Value;
            _TransformSkew.CenterY = _SliderSkewPointY.Value;

            _TransformTranslate.X = _SliderTranslateX.Value;
            _TransformTranslate.Y = _SliderTranslateY.Value;
        }

        private void Restore(Object sender, RoutedEventArgs e)
        {
            _SliderRotateAngle.Value = _SliderRotatePointX.Value = _SliderRotatePointY.Value = 0;
            _SliderTranslateX.Value = _SliderTranslateY.Value = _SliderScalePointX.Value = _SliderScalePointY.Value = 0;
            _SliderSkewX.Value = _SliderSkewY.Value = _SliderSkewPointX.Value = _SliderSkewPointY.Value = 0;
            _SliderScaleX.Value = _SliderScaleY.Value = 1;
        }
    }
}
